diff --git a/lib/libsdp/session.c b/lib/libsdp/session.c
index 1c3c402c24..e301e91bab 100644
--- a/lib/libsdp/session.c
+++ b/lib/libsdp/session.c
@@ -1,36 +1,3 @@
-/* $NetBSD: session.c,v 1.2 2007/04/07 21:08:46 plunky Exp $ */
-/* $DragonFly: src/lib/libsdp/session.c,v 1.1 2008/01/03 11:47:53 hasso Exp $ */
-
-/*-
- * Copyright (c) 2006 Itronix Inc.
- * All rights reserved.
- *
- * Written by Iain Hibbert for Itronix Inc.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of Itronix Inc. may not be used to endorse
- *    or promote products derived from this software without specific
- *    prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
 /*
  * session.c
  *
@@ -43,10 +10,10 @@
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
+ *    notice, this list of conditions and the following disclaimer in the 
  *    documentation and/or other materials provided with the distribution.
  *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND 
  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
@@ -58,12 +25,10 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: session.c,v 1.2 2007/04/07 21:08:46 plunky Exp $
- * $FreeBSD: src/lib/libsdp/session.c,v 1.3 2004/01/09 22:44:28 emax Exp $
+ * $Id: session.c,v 1.2 2003/09/04 22:12:13 max Exp $
+ * $FreeBSD: head/lib/libsdp/session.c 124317 2004-01-09 22:44:28Z emax $
  */
 
-#include <sys/types.h>
-#include <sys/un.h>
 #include <bluetooth.h>
 #include <errno.h>
 #include <stdlib.h>
@@ -77,8 +42,7 @@ void *
 sdp_open(bdaddr_t const *l, bdaddr_t const *r)
 {
 	sdp_session_p		ss = NULL;
-	struct sockaddr_bt	sa;
-	struct linger		li;
+	struct sockaddr_l2cap	sa;
 	socklen_t		size;
 
 	if ((ss = calloc(1, sizeof(*ss))) == NULL)
@@ -89,53 +53,45 @@ sdp_open(bdaddr_t const *l, bdaddr_t const *r)
 		goto fail;
 	}
 
-	ss->s = socket(PF_BLUETOOTH, SOCK_SEQPACKET, BTPROTO_L2CAP);
+	ss->s = socket(PF_BLUETOOTH, SOCK_SEQPACKET, BLUETOOTH_PROTO_L2CAP);
 	if (ss->s < 0) {
 		ss->error = errno;
 		goto fail;
 	}
 
-	memset(&li, 0, sizeof(li));
-	li.l_onoff = 1;
-	li.l_linger = 5;
-	if (setsockopt(ss->s, SOL_SOCKET, SO_LINGER, &li, sizeof(li)) < 0) {
-		ss->error = errno;
-		goto fail;
-	}
-
-	memset(&sa, 0, sizeof(sa));
-	sa.bt_len = sizeof(sa);
-	sa.bt_family = AF_BLUETOOTH;
-	bdaddr_copy(&sa.bt_bdaddr, l);
-	if (bind(ss->s, (void *) &sa, sizeof(sa)) < 0) {
+	sa.l2cap_len = sizeof(sa);
+	sa.l2cap_family = AF_BLUETOOTH;
+	sa.l2cap_psm = 0;
+	memcpy(&sa.l2cap_bdaddr, l, sizeof(sa.l2cap_bdaddr));
+	if (bind(ss->s, (struct sockaddr *) &sa, sizeof(sa)) < 0) {
 		ss->error = errno;
 		goto fail;
 	}
 
-	sa.bt_psm = L2CAP_PSM_SDP;
-	bdaddr_copy(&sa.bt_bdaddr, r);
-	if (connect(ss->s, (void *) &sa, sizeof(sa)) < 0) {
+	sa.l2cap_psm = htole16(NG_L2CAP_PSM_SDP);
+	memcpy(&sa.l2cap_bdaddr, r, sizeof(sa.l2cap_bdaddr));
+	if (connect(ss->s, (struct sockaddr *) &sa, sizeof(sa)) < 0) {
 		ss->error = errno;
 		goto fail;
 	}
 
 	size = sizeof(ss->omtu);
-	if (getsockopt(ss->s, BTPROTO_L2CAP, SO_L2CAP_OMTU, &ss->omtu, &size) < 0) {
+	if (getsockopt(ss->s, SOL_L2CAP, SO_L2CAP_OMTU, &ss->omtu, &size) < 0) {
 		ss->error = errno;
 		goto fail;
 	}
-	if ((ss->req = malloc((size_t)ss->omtu)) == NULL) {
+	if ((ss->req = malloc(ss->omtu)) == NULL) {
 		ss->error = ENOMEM;
 		goto fail;
 	}
 	ss->req_e = ss->req + ss->omtu;
 
 	size = sizeof(ss->imtu);
-	if (getsockopt(ss->s, BTPROTO_L2CAP, SO_L2CAP_IMTU, &ss->imtu, &size) < 0) {
+	if (getsockopt(ss->s, SOL_L2CAP, SO_L2CAP_IMTU, &ss->imtu, &size) < 0) {
 		ss->error = errno;
 		goto fail;
 	}
-	if ((ss->rsp = malloc((size_t)ss->imtu)) == NULL) {
+	if ((ss->rsp = malloc(ss->imtu)) == NULL) {
 		ss->error = ENOMEM;
 		goto fail;
 	}
@@ -154,7 +110,7 @@ sdp_open_local(char const *control)
 	if ((ss = calloc(1, sizeof(*ss))) == NULL)
 		goto fail;
 
-	ss->s = socket(PF_LOCAL, SOCK_STREAM, 0);
+	ss->s = socket(PF_UNIX, SOCK_STREAM, 0);
 	if (ss->s < 0) {
 		ss->error = errno;
 		goto fail;
@@ -164,10 +120,10 @@ sdp_open_local(char const *control)
 		control = SDP_LOCAL_PATH;
 
 	sa.sun_len = sizeof(sa);
-	sa.sun_family = AF_LOCAL;
+	sa.sun_family = AF_UNIX;
 	strlcpy(sa.sun_path, control, sizeof(sa.sun_path));
 
-	if (connect(ss->s, (void *) &sa, sizeof(sa)) < 0) {
+	if (connect(ss->s, (struct sockaddr *) &sa, sizeof(sa)) < 0) {
 		ss->error = errno;
 		goto fail;
 	}
@@ -175,13 +131,13 @@ sdp_open_local(char const *control)
 	ss->flags |= SDP_SESSION_LOCAL;
 	ss->imtu = ss->omtu = SDP_LOCAL_MTU;
 
-	if ((ss->req = malloc((size_t)ss->omtu)) == NULL) {
+	if ((ss->req = malloc(ss->omtu)) == NULL) {
 		ss->error = ENOMEM;
 		goto fail;
 	}
 	ss->req_e = ss->req + ss->omtu;
 
-	if ((ss->rsp = malloc((size_t)ss->imtu)) == NULL) {
+	if ((ss->rsp = malloc(ss->imtu)) == NULL) {
 		ss->error = ENOMEM;
 		goto fail;
 	}
diff --git a/lib/libsdp/util.c b/lib/libsdp/util.c
index 3a62c52b6e..410fcc5aa9 100644
--- a/lib/libsdp/util.c
+++ b/lib/libsdp/util.c
@@ -1,36 +1,3 @@
-/* $NetBSD: util.c,v 1.1 2006/06/19 15:44:36 gdamore Exp $ */
-/* $DragonFly: src/lib/libsdp/util.c,v 1.2 2008/09/30 16:57:05 swildner Exp $ */
-
-/*-
- * Copyright (c) 2006 Itronix Inc.
- * All rights reserved.
- *
- * Written by Iain Hibbert for Itronix Inc.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of Itronix Inc. may not be used to endorse
- *    or promote products derived from this software without specific
- *    prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
 /*
  * util.c
  *
@@ -43,10 +10,10 @@
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
+ *    notice, this list of conditions and the following disclaimer in the 
  *    documentation and/or other materials provided with the distribution.
  *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND 
  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
@@ -58,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: util.c,v 1.1 2006/06/19 15:44:36 gdamore Exp $
- * $FreeBSD: src/lib/libsdp/util.c,v 1.5 2005/05/27 19:11:33 emax Exp $
+ * $Id: util.c,v 1.5 2003/09/08 02:29:35 max Exp $
+ * $FreeBSD: head/lib/libsdp/util.c 161662 2006-08-26 23:16:35Z markus $
  */
 
 #include <netinet/in.h>
@@ -150,6 +117,9 @@ static sdp_attr_desc_t	sdp_uuids_desc[] = {
 { SDP_SERVICE_CLASS_UDI_TA, "UDI TA", },
 { SDP_SERVICE_CLASS_AUDIO_VIDEO, "Audio/Video", },
 { SDP_SERVICE_CLASS_SIM_ACCESS, "SIM Access", },
+{ SDP_SERVICE_CLASS_PHONEBOOK_ACCESS_PCE, "Phonebook Access - PCE", },
+{ SDP_SERVICE_CLASS_PHONEBOOK_ACCESS_PSE, "Phonebook Access - PSE", },
+{ SDP_SERVICE_CLASS_PHONEBOOK_ACCESS, "Phonebook Access", },
 { SDP_SERVICE_CLASS_PNP_INFORMATION, "PNP Information", },
 { SDP_SERVICE_CLASS_GENERIC_NETWORKING, "Generic Networking", },
 { SDP_SERVICE_CLASS_GENERIC_FILE_TRANSFER, "Generic File Transfer", },
@@ -160,6 +130,9 @@ static sdp_attr_desc_t	sdp_uuids_desc[] = {
 { SDP_SERVICE_CLASS_ESDP_UPNP_IP_PAN, "ESDP UPNP IP PAN", },
 { SDP_SERVICE_CLASS_ESDP_UPNP_IP_LAP, "ESDP UPNP IP LAP", },
 { SDP_SERVICE_CLASS_ESDP_UPNP_L2CAP, "ESDP UPNP L2CAP", },
+{ SDP_SERVICE_CLASS_VIDEO_SOURCE, "Video Source", },
+{ SDP_SERVICE_CLASS_VIDEO_SINK, "Video Sink", },
+{ SDP_SERVICE_CLASS_VIDEO_DISTRIBUTION, "Video Distribution", },
 { 0xffff, NULL, }
 };
 
@@ -193,7 +166,7 @@ static sdp_attr_desc_t	sdp_attrs_desc[] = {
   },
 { SDP_ATTR_BLUETOOTH_PROFILE_DESCRIPTOR_LIST,
   "Bluetooh Profile Descriptor List",
-  },
+  }, 
 { SDP_ATTR_DOCUMENTATION_URL,
   "Documentation URL",
   },
@@ -274,13 +247,16 @@ static sdp_attr_desc_t	sdp_attrs_desc[] = {
 { SDP_ATTR_TOTAL_IMAGING_DATA_CAPACITY,
   "Total Imaging Data Capacity",
   },
+{ SDP_ATTR_SUPPORTED_REPOSITORIES,
+  "Supported Repositories",
+  },
 { 0xffff, NULL, }
 };
 
 char const *
 sdp_attr2desc(uint16_t attr)
 {
-	sdp_attr_desc_p	a = sdp_attrs_desc;
+	register sdp_attr_desc_p	a = sdp_attrs_desc;
 
 	for (; a->desc != NULL; a++)
 		if (attr == a->attr)
@@ -292,7 +268,7 @@ sdp_attr2desc(uint16_t attr)
 char const *
 sdp_uuid2desc(uint16_t uuid)
 {
-	sdp_attr_desc_p	a = sdp_uuids_desc;
+	register sdp_attr_desc_p	a = sdp_uuids_desc;
 
 	for (; a->desc != NULL; a++)
 		if (uuid == a->attr)
@@ -302,7 +278,7 @@ sdp_uuid2desc(uint16_t uuid)
 }
 
 void
-sdp_print(uint32_t level, uint8_t *start, uint8_t const *end)
+sdp_print(uint32_t level, uint8_t const *start, uint8_t const *end)
 {
 	union {
 		int8_t		int8;
@@ -352,37 +328,22 @@ sdp_print(uint32_t level, uint8_t *start, uint8_t const *end)
 		case SDP_DATA_UINT128:
 		case SDP_DATA_INT128:
 			SDP_GET128(&value.int128, start);
-			printf("u/int128 0x"
-				"%2.2x%2.2x%2.2x%2.2x"
-				"%2.2x%2.2x%2.2x%2.2x"
-				"%2.2x%2.2x%2.2x%2.2x"
-				"%2.2x%2.2x%2.2x%2.2x\n",
-				value.int128.b[ 0], value.int128.b[ 1],
-				value.int128.b[ 2], value.int128.b[ 3],
-				value.int128.b[ 4], value.int128.b[ 5],
-				value.int128.b[ 6], value.int128.b[ 7],
-				value.int128.b[ 8], value.int128.b[ 9],
-				value.int128.b[10], value.int128.b[11],
-				value.int128.b[12], value.int128.b[13],
-				value.int128.b[14], value.int128.b[15]);
+			printf("u/int128 %#8.8x%8.8x%8.8x%8.8x\n",
+				*(uint32_t *)&value.int128.b[0],
+				*(uint32_t *)&value.int128.b[4],
+				*(uint32_t *)&value.int128.b[8],
+				*(uint32_t *)&value.int128.b[12]);
 			break;
 
 		case SDP_DATA_UUID128:
 			SDP_GET_UUID128(&value.int128, start);
-			printf("uuid128 0x"
-				"%2.2x%2.2x%2.2x%2.2x-"
-				"%2.2x%2.2x-"
-				"%2.2x%2.2x-"
-				"%2.2x%2.2x-"
-				"%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
-				value.int128.b[ 0], value.int128.b[ 1],
-				value.int128.b[ 2], value.int128.b[ 3],
-				value.int128.b[ 4], value.int128.b[ 5],
-				value.int128.b[ 6], value.int128.b[ 7],
-				value.int128.b[ 8], value.int128.b[ 9],
-				value.int128.b[10], value.int128.b[11],
-				value.int128.b[12], value.int128.b[13],
-				value.int128.b[14], value.int128.b[15]);
+			printf("uuid128 %#8.8x-%4.4x-%4.4x-%4.4x-%4.4x%8.8x\n",
+				ntohl(*(uint32_t *)&value.int128.b[0]),
+				ntohs(*(uint16_t *)&value.int128.b[4]),
+				ntohs(*(uint16_t *)&value.int128.b[6]),
+				ntohs(*(uint16_t *)&value.int128.b[8]),
+				ntohs(*(uint16_t *)&value.int128.b[10]),
+				ntohl(*(uint32_t *)&value.int128.b[12]));
 			break;
 
 		case SDP_DATA_INT8:
@@ -401,7 +362,7 @@ sdp_print(uint32_t level, uint8_t *start, uint8_t const *end)
 			SDP_GET64(value.int64, start);
 			printf("int64 %ju\n", value.int64);
 			break;
-
+	
 		case SDP_DATA_UUID16:
 			SDP_GET16(value.uint16, start);
 			printf("uuid16 %#4.4x - %s\n", value.uint16,
@@ -486,10 +447,11 @@ sdp_print(uint32_t level, uint8_t *start, uint8_t const *end)
 			printf("url32 %*.*s\n", value.uint32, value.uint32, start);
 			start += value.uint32;
 			break;
-
+	
 		default:
 			printf("unknown data type: %#02x\n", *start ++);
 			break;
 		}
 	}
 }
+
diff --git a/share/examples/etc/README.examples b/share/examples/etc/README.examples
index d6405793e1..72e6eba3b4 100644
--- a/share/examples/etc/README.examples
+++ b/share/examples/etc/README.examples
@@ -68,6 +68,7 @@ sysctl.conf	- kernel state defaults
 syslog.conf	- configuration file for syslogd(8)
 ttys		- defines port configuration for init(8)
 defaults/	- directory containing default configuration files
+defaults/bluetooth.device.conf	- default Bluetooth device configuration file
 defaults/compilers.conf	- default configuration for non-base compilers
 defaults/devfs.conf	- default rule file for devfs(5)
 defaults/make.conf	- system build default information
diff --git a/share/man/man4/Makefile b/share/man/man4/Makefile
index 93c8c48603..08128cfaba 100644
--- a/share/man/man4/Makefile
+++ b/share/man/man4/Makefile
@@ -49,7 +49,6 @@ MAN=	aac.4 \
 	bge.4 \
 	bktr.4 \
 	blackhole.4 \
-	bluetooth.4 \
 	bnx.4 \
 	bpf.4 \
 	bridge.4 \
@@ -334,7 +333,6 @@ MAN=	aac.4 \
 	ubsa.4 \
 	ubsec.4 \
 	ubser.4 \
-	ubt.4 \
 	uchcom.4 \
 	ucycom.4 \
 	ucom.4 \
diff --git a/sys/Makefile b/sys/Makefile
index f0bb239cdd..f50168b884 100644
--- a/sys/Makefile
+++ b/sys/Makefile
@@ -11,7 +11,7 @@ SUBDIR=	boot
 .if defined(MODULES_OVERRIDE)
 SUBDIR+=${MODULES_OVERRIDE}
 .else
-SUBDIR+=bus crypto dev emulation gnu kern net netbt netproto vfs
+SUBDIR+=bus crypto dev emulation gnu kern net netproto vfs
 .if defined(WANT_NETGRAPH7)
 SUBDIR+=netgraph7
 .else
diff --git a/sys/Makefile.modules b/sys/Makefile.modules
index afacc19c91..b6311f7d13 100644
--- a/sys/Makefile.modules
+++ b/sys/Makefile.modules
@@ -7,7 +7,7 @@ SUBDIR=${MODULES_OVERRIDE}
 .if ${MACHINE_PLATFORM} != "vkernel64"
 SUBDIR=bus
 .endif
-SUBDIR+=crypto emulation dev gnu kern net netbt netproto vfs
+SUBDIR+=crypto emulation dev gnu kern net netproto vfs
 .if defined(WANT_NETGRAPH7)
 SUBDIR+=netgraph7
 .else
diff --git a/sys/conf/files b/sys/conf/files
index 6966aeac95..63417beb93 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -1584,25 +1584,6 @@ net/raw_cb.c		standard
 net/raw_usrreq.c	standard
 net/route.c		standard
 net/rtsock.c		standard
-netbt/bt_input.c	optional bluetooth
-netbt/bt_proto.c	optional bluetooth
-netbt/hci_event.c	optional bluetooth
-netbt/hci_ioctl.c	optional bluetooth
-netbt/hci_link.c	optional bluetooth
-netbt/hci_misc.c	optional bluetooth
-netbt/hci_socket.c	optional bluetooth
-netbt/hci_unit.c	optional bluetooth
-netbt/l2cap_lower.c	optional bluetooth
-netbt/l2cap_misc.c	optional bluetooth
-netbt/l2cap_signal.c	optional bluetooth
-netbt/l2cap_socket.c	optional bluetooth
-netbt/l2cap_upper.c	optional bluetooth
-netbt/rfcomm_dlc.c	optional bluetooth
-netbt/rfcomm_session.c	optional bluetooth
-netbt/rfcomm_socket.c	optional bluetooth
-netbt/rfcomm_upper.c	optional bluetooth
-netbt/sco_socket.c	optional bluetooth
-netbt/sco_upper.c	optional bluetooth
 netproto/802_11/wlan/ieee80211.c            optional wlan
 netproto/802_11/wlan_acl/ieee80211_acl.c    optional wlan_acl
 netproto/802_11/wlan/ieee80211_action.c     optional wlan
diff --git a/sys/config/LINT64 b/sys/config/LINT64
index 05f079579b..b90fed37bd 100644
--- a/sys/config/LINT64
+++ b/sys/config/LINT64
@@ -1150,9 +1150,6 @@ device		iwnfw
 device		ralfw
 device		wpifw
 
-# Bluetooth Protocols
-device		bluetooth
-
 # Sound drivers
 #
 
diff --git a/usr.bin/Makefile b/usr.bin/Makefile
index 43660f29ca..5f0501352d 100644
--- a/usr.bin/Makefile
+++ b/usr.bin/Makefile
@@ -18,7 +18,8 @@ SUBDIR=	alias \
 	bmake \
 	brandelf \
 	bsdcat \
-	btpin \
+	bthost \
+	btsockstat \
 	bzip2 \
 	bzip2recover \
 	c89 \
@@ -167,7 +168,6 @@ SUBDIR=	alias \
 	rwho \
 	scp \
 	script \
-	sdpquery \
 	sed \
 	seq \
 	sftp \
diff --git a/usr.bin/bthost/Makefile b/usr.bin/bthost/Makefile
new file mode 100644
index 0000000000..27b14428fc
--- /dev/null
+++ b/usr.bin/bthost/Makefile
@@ -0,0 +1,9 @@
+# $Id: Makefile,v 1.4 2003/08/14 20:07:13 max Exp $
+# $FreeBSD: head/usr.bin/bluetooth/bthost/Makefile 201386 2010-01-02 10:27:05Z ed $
+
+PROG=		bthost
+
+DPADD=		${LIBBLUETOOTH}
+LDADD=		-lbluetooth 
+
+.include <bsd.prog.mk>
diff --git a/usr.bin/bthost/bthost.c b/usr.bin/bthost/bthost.c
new file mode 100644
index 0000000000..72b5eb6d7a
--- /dev/null
+++ b/usr.bin/bthost/bthost.c
@@ -0,0 +1,142 @@
+/*
+ * bthost.c
+ *
+ * Copyright (c) 2003 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: bthost.c,v 1.5 2003/05/21 20:30:01 max Exp $
+ * $FreeBSD: head/usr.bin/bluetooth/bthost/bthost.c 121054 2003-10-12 22:04:24Z emax $
+ */
+
+#include <bluetooth.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+static int  hostmode  (char const *arg, int brief);
+static int  protomode (char const *arg, int brief);
+static void usage     (void);
+
+int
+main(int argc, char **argv)
+{
+	int	opt, brief = 0, proto = 0;
+
+	while ((opt = getopt(argc, argv, "bhp")) != -1) {
+		switch (opt) {
+		case 'b':
+			brief = 1;
+			break;
+
+		case 'p':
+			proto = 1;
+			break;
+
+		case 'h':
+		default:
+			usage();
+			/* NOT REACHED */
+		}
+	}
+
+	argc -= optind;
+	argv += optind;
+
+	if (argc < 1)
+		usage();
+
+	exit(proto? protomode(*argv, brief) : hostmode(*argv, brief));
+}
+
+static int
+hostmode(char const *arg, int brief)
+{
+	struct hostent	*he = NULL;
+	bdaddr_t	 ba;
+	char		 bastr[32];
+	int		 reverse;
+
+	if (bt_aton(arg, &ba) == 1) {
+		reverse = 1;
+		he = bt_gethostbyaddr((char const *) &ba, sizeof(ba), 
+					AF_BLUETOOTH);
+	} else {
+		reverse = 0;
+		he = bt_gethostbyname(arg);
+	}
+
+	if (he == NULL) {
+		herror(reverse? bt_ntoa(&ba, bastr) : arg);
+		return (1);
+	}
+
+	if (brief)
+		printf("%s", reverse? he->h_name :
+				bt_ntoa((bdaddr_t *)(he->h_addr), bastr));
+	else
+		printf("Host %s has %s %s\n", 
+			reverse? bt_ntoa(&ba, bastr) : arg,
+			reverse? "name" : "address",
+			reverse? he->h_name :
+				bt_ntoa((bdaddr_t *)(he->h_addr), bastr));
+
+	return (0);
+}
+
+static int
+protomode(char const *arg, int brief)
+{
+	struct protoent	*pe = NULL;
+	int		 proto;
+
+	if ((proto = atoi(arg)) != 0)
+		pe = bt_getprotobynumber(proto);
+	else
+		pe = bt_getprotobyname(arg);
+
+	if (pe == NULL) {
+		fprintf(stderr, "%s: Unknown Protocol/Service Multiplexor\n", arg);
+		return (1);
+	}
+
+	if (brief) {
+		if (proto)
+			printf("%s", pe->p_name);
+		else
+			printf("%d", pe->p_proto);
+	} else {
+		printf("Protocol/Service Multiplexor %s has number %d\n",
+			pe->p_name, pe->p_proto);
+	}
+
+	return (0);
+}
+
+static void
+usage(void)
+{
+	fprintf(stdout, "Usage: bthost [-b -h -p] host_or_protocol\n");
+	exit(255);
+}
+
diff --git a/usr.bin/btsockstat/Makefile b/usr.bin/btsockstat/Makefile
new file mode 100644
index 0000000000..baa14db7cf
--- /dev/null
+++ b/usr.bin/btsockstat/Makefile
@@ -0,0 +1,12 @@
+# $Id: Makefile,v 1.7 2003/08/14 20:07:14 max Exp $
+# $FreeBSD: head/usr.bin/bluetooth/btsockstat/Makefile 140941 2005-01-28 16:08:11Z ru $
+
+PROG=		btsockstat
+WARNS?=		2
+BINGRP=		kmem
+BINMODE=	2555
+
+DPADD=		${LIBBLUETOOTH} ${LIBKVM}
+LDADD=		-lbluetooth -lkvm
+
+.include <bsd.prog.mk>
